#error NOT FINISHED

/*

  Exp-6 (Buckingham) potential for COOK and BLEND
  with Lennard-Jones combining rules

                 /  6                       a           6 \
    u(r) = eps * | --- exp[a(1-r/sigma)] - --- (sigma/r)  |
                 \ a-6                     a-6            /

  (a is parm[0], eps = |E_min|)

  #ifdef REPULSIVE then the r^-6 term is turned off

  this module modifies interpot.c and partly cook/simdef.c 
*/

#ifndef SITE_SITE
#define SITE_SITE

#ifdef REPULSIVE
#define SS_TABLE "repulsive-exp-6"
#define TURNVDW 0* /* just multiply by 0 */
#else
#define SS_TABLE "exp-6"
#define TURNVDW /*empty*/
#endif

#  include "simopt.h"
#  include "units.h"
#  include "int4.h"

#    define SS_PARMS      1
#    define DECLARE_INITCOMBRULE /* */

typedef struct pairaux_s {
  real tau,eu,ef,ru,rf;
} pairaux_t;

#  include "ssdecl.h"

/* macro calculation auxiliary constants for site-site interactions */
#define SS_DEF \
  ss->tau=-(parm[0]/sigvdW);                  \
  ss->eu=-6*epsvdW/(parm[0]-6)*exp(parm[0]);   \
  ss->ef=ss->eu*(parm[0]/sigvdW);             \
  ss->ru=TURNVDW epsvdW*parm[0]*Pow6(sigvdW)/(parm[0]-6); \
  ss->rf=TURNVDW 6*ss->ru;

/* warning: fix of negative u(r) at very small r removed, fingers crossed */

/* macros defining potential and force=-dU/dr (used by setss) */
double ss_u(double,double,double,double);
double ss_f(double,double,double,double);
#define SS_U(r) ss_u(r,sigvdW,epsvdW,parm[0])
#define SS_F(r) ss_f(r,sigvdW,epsvdW,parm[0])

/* LJ/exp-6 in site-site functions with measurements included */
#define SS_MEASURE { \
  x=sqrt(rr); /* double eval? */   \
  y=exp(ss->tau*x);                \
  z=Cub(rr);                       \
  U=ss->eu*y-TURNVDW ss->ru/z;     \
  f=ss->ef*y/x-TURNVDW ss->rf/z/rr; }

/* no measurements */
#define SS_NOMEASURE(OP) { \
  double z;                \
  x=sqrt(rr);              \
  y=exp(ss->tau*x);        \
  z=Cub(rr);               \
  f OP ss->ef*y/x-TURNVDW ss->rf/z/rr; }

#endif

#endif /* SITE_SITE */
